#include <stdio.h>
#include "graph.h"
#include <stdlib.h>
#include <math.h>
#include <time.h> 
#include <sys/time.h> 


#define INF 1000
#define MASKSIZE 5 
#define DISPMAX 60
#define C 1


unsigned char *Read_Ppm(char *filename, int *ret_width,int *ret_height,int *ret_depth)
{
  FILE *fp;
  unsigned char format;
  unsigned char *data;
  char *buffer;
  int width,height,depth;
  int i,j,k;
  int tmp_count;
  
  if((fp=fopen(filename,"r"))==NULL)
    return NULL;
  buffer=(char*)malloc(sizeof(char)*256);
  
  fgets(buffer,256,fp);
  if(strcmp(buffer,"P3\n")==0)
    format=0;
  else
    format=1;
  fgets(buffer,256,fp);
  while(buffer[0]=='#')
    fgets(buffer,256,fp);
  tmp_count=sscanf(buffer,"%d %d %d",&width,&height,&depth);
  if(tmp_count==1)
    fscanf(fp,"%d %d",&height,&depth);
  else if(tmp_count==2)
    fscanf(fp,"%d",&depth);
  
  data=(unsigned char*)malloc(sizeof(unsigned char)*width*height*3);
  
  if(format==0)
    {
      for(i=0;i<height;++i)
	for(j=0;j<width;++j)
	  for(k=0;k<3;++k)
	    fscanf(fp,"%hhd",&data[(i*width*3)+(j*3)+k]);
    }
  else
    fread(data,sizeof(unsigned char),width*height*3,fp);    
  
  fclose(fp);
  
  if(ret_width!=NULL)
    *ret_width=width;
  if(ret_height!=NULL)
    *ret_height=height;
  if(ret_depth!=NULL)
    *ret_depth=depth;
  
  return data;
}




/******************************* $B%G!<%?%3%9%H4X?t(B ******************************/
float D(int x, int y, unsigned char* leftImage, unsigned char* rightImage, int width, int height, int d)
{
	unsigned int* mask = new unsigned int[MASKSIZE*MASKSIZE*3];
	unsigned int* comp = new unsigned int[MASKSIZE*MASKSIZE*3];
	float sum;
	

	int i,j;	


	//$B%^%9%/2hA|$N:n@.(B
	for(int v = y-2, i = 0; v <= y+2; v++, i++){
		for(int u = x-2,j = 0; u <= x+2; u++, j++){
			if(v < 0 || u < 0 || v >= height || u >= width){
				mask[(j + i * MASKSIZE) * 3 + 0] = INF;
				mask[(j + i * MASKSIZE) * 3 + 1] = INF;
				mask[(j + i * MASKSIZE) * 3 + 2] = INF;
			}
			else{
				mask[(j + i * MASKSIZE) * 3 + 0] = (int)leftImage[(u + v * width) * 3 + 0];
				mask[(j + i * MASKSIZE) * 3 + 1] = (int)leftImage[(u + v * width) * 3 + 1];
				mask[(j + i * MASKSIZE) * 3 + 2] = (int)leftImage[(u + v * width) * 3 + 2];				
			}
		}
	}
	
	
	//$BHf3S2hA|$N:n@.(B
	for(int v = y-2, i = 0; v <= y+2, i < MASKSIZE; v++, i++){
		for(int u = (x-d)-2, j = 0; u <= (x-d)+2, j < MASKSIZE; u++, j++){
			if(v < 0 || u < 0 || v >= height || u >= width){
				comp[(j + i * MASKSIZE) * 3 + 0] = INF;
				comp[(j + i * MASKSIZE) * 3 + 1] = INF;
				comp[(j + i * MASKSIZE) * 3 + 2] = INF;
			}
			else{
				comp[(j + i * MASKSIZE) * 3 + 0] = (int)rightImage[(u + v * width) * 3 + 0];
				comp[(j + i * MASKSIZE) * 3 + 1] = (int)rightImage[(u + v * width) * 3 + 1];
				comp[(j + i * MASKSIZE) * 3 + 2] = (int)rightImage[(u + v * width) * 3 + 2];				
			}
		}
	}

	sum = 0;
	//$B%^%9%/2hA|$H$NHf3S(B
	for(int i = 0; i < MASKSIZE; i++){
		for(int j = 0; j < MASKSIZE; j++){
			if(mask[(j + i * MASKSIZE) * 3 + 0] != INF && comp[(j + i * MASKSIZE) * 3 + 0] != INF){
				sum += abs(mask[(j + i * MASKSIZE) * 3 + 0] - comp[(j + i * MASKSIZE) * 3 + 0]) +
						abs(mask[(j + i * MASKSIZE) * 3 + 1] - comp[(j + i * MASKSIZE) * 3 + 1]) +
						abs(mask[(j + i * MASKSIZE) * 3 + 2] - comp[(j + i * MASKSIZE) * 3 + 2]);
			}
		}
	}

	delete [] mask;
	delete [] comp;


	//fprintf(stderr,"sum = %f\n",sum);
	return sum;

}


double gettimeofday_sec()
{ 
	struct timeval tv;
 	gettimeofday(&tv, NULL); 
 	
 	return tv.tv_sec + tv.tv_usec * 1e-6;
} 



int main( int argc, char *argv[] )
{
  
  	int i, j, x, y, width, height, depth; 
  	unsigned char *left_data, *right_data;
  	int node;
  	
  	int alpha;
  	
  	float SORCE,SINK;
  	
  	float weightLeft;
	float weightRight;
	
	float weightAbove;
	float weightBelow;


	// $B$=$l$>$l!":81&$H>e2<$N%N!<%I$NCM$r:n@=$9$k$H$-$KMQ$$$k(B
	int sayuNodeNum;
	int jogeNodeNum;
	
	double t1, t2; 
	
	t1 = gettimeofday_sec(); 
	
	
  	node=0;


  	FILE *outputfile;     
  
 	left_data = Read_Ppm(argv[1], &width, &height, &depth);
	right_data = Read_Ppm(argv[2], &width, &height, &depth);
  	//output_data= Read_Ppm("inputfile.ppm", &width, &height, &depth);
  
  	unsigned char* Fp = new unsigned char[width*height];
  	unsigned char* temp_Fp = new unsigned char[width*height];
	unsigned char* out_Fp = new unsigned char[width*height];
	
  	typedef Graph<float,float,float> GraphType;


  	int Large = 500000000;
  	double E  = 500000000;



  
  	for(int p = 0; p < width*height; p++){
   	 Fp[p] = 0;
   	 temp_Fp[p] = 0;
   	 		
   	 	}

  	for(i = 0; i < Large; i++){
      	int success = 0;
      
      	for(alpha = 0; alpha < DISPMAX; alpha++){
	  		//$B%0%i%U$N=i4|2=(B
	  		GraphType *g = new GraphType(/*estimated # of nodes*/ width * height + (width - 1) * height + width * (height - 1), 
				/*estimated # of edges*/ (width - 1) * 2 * height + width * 2 * (height - 1)); 

	   
	   		//$BA4$F$N%N!<%I$NDI2C(B
	   	g -> add_node(width * height + (width - 1) * height + width * (height - 1)); 

	   	node = 0;
	   	for(y = 0; y < height; y++){
	     		for(x = 0; x < width; x++){
	       		SORCE = D(x, y, left_data, right_data, width, height, temp_Fp[x + y * width]);
	       		SINK = D(x, y, left_data, right_data, width, height, alpha);
	       		g -> add_tweights( node,SORCE, SINK );
	       		node++;
	     		}
	   		}
	   
			
	   	int edgenum = width * height;
	   	for(int v = 0; v < height; v++){
	     		for(int u = 0; u < width-1; u++){	  
	     		
	     			// $B@5$7$$&A3HD%$r<BAu$9$k$?$a$K!"DI2C$9$k%N!<%I$N:81&$r3NG'$9$k(B
					// $B$=$N%N!<%IF1;N$NCM$,F1$8$G$"$l$P!"""$NDI2C$O$J$7!#JQ$o$j$K!{F1;N$K%(%C%8$r:n@=$9$k(B
					if( temp_Fp[u + v * width] == temp_Fp[(u+1) + v * width] ){
						// $B:81&$N%N!<%I$X$N=E$_$r:n@=!#(B
						weightLeft = C * abs(temp_Fp[u + v * width] - alpha);
						
						// $B:8B&$N%N!<%I!{$N%N!<%IHV9f$r@8@.(B
						sayuNodeNum = v*width+u;

						// $B:81&$N%N!<%I!{$X$N%(%C%8$r:n@=(B
						g -> add_edge( sayuNodeNum, sayuNodeNum+1,   /* capacities */  weightLeft, weightLeft);
					}
					else{
						SORCE = C * abs(temp_Fp[u + v * width] - temp_Fp[(u+1) + v * width]);
						//Sink $B$OI,$:%<%m(B 
						SINK = 0;
						
						g -> add_tweights( node,   /* capacities */  SORCE, SINK);
						
						// $B:81&$N%N!<%I!{$X$N=E$_$r:n@=(B
						weightLeft  = C * abs(temp_Fp[u + v * width]   - alpha);
						weightRight = C * abs(temp_Fp[(u+1) + v * width] - alpha);
						
						// $B:81&$N%N!<%I!{$N%N!<%IHV9f$r@8@.(B
						sayuNodeNum = v*width+u;		
						
						// $B:81&$N%N!<%I!{$X$N%(%C%8$r:n@=(B
						g -> add_edge( node, sayuNodeNum,    /* capacities */  weightLeft, weightLeft );
						g -> add_edge( node, sayuNodeNum+1,    /* capacities */  weightRight, weightRight );

						node++;
					}
				}
			}
			
			
			// $B2hAGF1;N$N4V$N!V=D!W$N%N!<%I$rDI2C(B
			for(int v = 0; v < height-1; v++){
	     		for(int u = 0; u < width; u++){
	     			// $B@5$7$$&A3HD%$r<BAu$9$k$?$a$K!"DI2C$9$k%N!<%I$N>e2<$r3NG'$9$k(B
					// $B$=$N%N!<%IF1;N$NCM$,F1$8$G$"$l$P!""$$NDI2C$O$J$7!#JQ$o$j$K!{F1;N$K%(%C%8$r:n@=$9$k(B
					
					
					if(temp_Fp[u + v * width] == temp_Fp[u + (v+1) * width]) {
						// $B%N!<%I!{F1;N$NCM$,F1$8>l9g(B

						// $B>e2<$N%N!<%I$X$N=E$_$r:n@=!#$3$l$O>e2<$H$b$KF1$8CM(B
						weightAbove = C * abs(temp_Fp[u + v * width] - alpha);

						// $B>eB&$N%N!<%I!{$N%N!<%IHV9f$r@8@.(B
						jogeNodeNum = v*width+u;

						// $B>e2<$N%N!<%I!{$X$N%(%C%8$r:n@=(B
						g -> add_edge( jogeNodeNum, jogeNodeNum+width,  weightAbove, weightAbove);
					}
					else{
						// $B"$$N>e2<$N%N!<%I!{F1;N$N:9!#$3$l$K(BSMOOTHCOST$B$r$+$1$?$b$N$r%=!<%9B&$X$N%3%9%H$H$9$k(B
						SORCE = C * abs(temp_Fp[u + v * width] - temp_Fp[u + (v+1) * width]);

						// weightSink $B$OI,$:%<%m(B
						SINK   = 0;

						g -> add_tweights( node,   /* capacities */  SORCE, SINK);


						// $B>e2<$N%N!<%I!{$X$N=E$_$r:n@=(B
						weightAbove = C * abs(temp_Fp[u + v * width]  - alpha);
						weightBelow = C * abs(temp_Fp[u + (v+1) * width] - alpha);

						// $B>e2<$N%N!<%I!{$N%N!<%IHV9f$r@8@.(B
						jogeNodeNum = v*width+u;

						// $B>e2<$N%N!<%I!{$X$N%(%C%8$r:n@=(B
						g -> add_edge( node, jogeNodeNum,    /* capacities */  weightAbove, weightAbove );
						g -> add_edge( node, jogeNodeNum+width,    /* capacities */  weightBelow, weightBelow );

						node++;
					}
				}
			}
			
			
			// $B0J2<!"(BMAXFLOW$B$G%N!<%I72$+$i%0%i%U%+%C%H$r:n@=(B
			// $B:GBgN.!&:G>.%+%C%H%"%k%4%j%:%`$NE,MQ(B
			double flow;
			flow = g -> maxflow();
			
			//fprintf(stderr, "flow = %f\n", flow);
			
			if(flow < E) {
				success = 1;
				E = flow;


				// $B8=:_$N%i%Y%k$r5a$^$C$?%i%Y%k$KJQ99$9$k(B
				// $B$D$^$j$O!"5a$^$C$?%0%i%U$r8+$F(BfpImage$B$NCM$r=q$-49$($h$&!"$H$$$&$3$H$@(B
				for(int y=0, node=0; y < height; y++) {
		
					for(int x=0; x < width; x++) {

						if (g->what_segment(node) == GraphType::SOURCE) {
							//printf("node%d is in the SOURCE set(J\n",(B currentNode);

							// $B%=!<%9B&$K4^$^$l$k$H$$$&$3$H$O%7%s%/B&$,@Z$i$l$F$$$k$H$$$&$3$H!#(B
							// $B$3$N>l9g!"2hAG$O%7%s%/B&$N%i%Y%k$K=$@5$9$k!#(B
							// $BF~NO2hAG$H%"%k%U%!$H$N:9(B
							//temp_fp[x] = abs(temp_ip[x]-alpha);

							// $B$b$7$+$7$?$i!"%i%Y%k$C$F$N$O&A$H$+(Bfp$B$H$+$+$b!#(B
							temp_Fp[x + y * width] = alpha;//(int)((float)temp_Fp[i]/DISPMAX*255);
						} else {
							// $B%7%s%/B&$N4^$^$l$k$H$$$&$3$H$O!"%=!<%9B&$,@Z$i$l$F$$$k$H$$$&$3$H(B
							// $B$3$N>l9g!"2hAG$O%=!<%9B&$N%i%Y%k$K=$@5$9$k(B
							// $BF~NO2hAG$H8=:_$NCM$H$N:9(B
							//temp_fp[x] = abs(temp_ip[x]-temp_fp[x]);

							// $B%i%Y%k$,(Bfp$B$N$^$^$J$N$G2?$b$7$J$$!#(B
						}

						node++;

					}
				}
	
			}
			
			delete g; 
			
			//fprintf(stderr, "alph = %d\n", alpha);
		}
		
		if(success == 0) break;
	}
	
	t2 = gettimeofday_sec();
	
	printf("\n");
	printf("$B<B9T;~4V(B = %f\n", t2 - t1);
	

  	outputfile = fopen(argv[3], "w");  
  	if (outputfile == NULL) {          
    	printf("cannot open\n");        
    	exit(1);                       
  	}
  	fprintf(outputfile, "P2\n"); 
  	fprintf(outputfile, "%d %d\n",width, height);
  	fprintf(outputfile, "%d\n",depth);
  	for (i = 0; i < width * height; i++) {
    	fprintf(outputfile, "%d\n", (int)((float)temp_Fp[i]/DISPMAX*255)/*temp_Fp[i]*/);
  	}
  	fclose(outputfile);        
  
  	return 0;
}
